{*************************************************************************}
{*                                                                       *}
{*                  III Olimpiada Informatyczna                          *}
{*                                                                       *}
{*   Rozwiazanie zadania: WYROWNYWANIE SLOW                              *}
{*   Plik:                WYR.PAS                                        *}
{*   Autor:               Wojciech Rytter                                *}
{*************************************************************************}

{$M 65500,0,655360}
program WyrownywanieSlow;
 const
  MaxTotalSize=5200;
  Max         =50;
 var
  Sufiks                       :array[1..MaxTotalSize] of char;
  Poczatek                     :array[1..Max] of integer;
  Odwiedzony                   :array[1..MaxTotalSize] of boolean;
  ZbiorOdwiedzonych            :array[1..MaxTotalSize] of integer;
  q                            :char;
  f                            :text;
  d,i,j,k,n,p,p1,p2            :integer;
  Koniec,NowyKoniec,StaryKoniec:integer;

 procedure WynikTak(d:integer);
 begin
  writeln(f,d);
  close(f);
  halt
 end; {WynikTak}

 procedure WynikNie;
 begin
  writeln(f,'NIE');
  close(f);
  halt
 end; {WynikNie}

 procedure WczytajDane;
 begin
  assign(f,'WYR.IN');
  reset(f);
  read(f,n);
  k:=0;
  for i:=1 to n+2 do begin
   Poczatek[i]:=k+1;
   read(f,d);  read(f,q);
   for j:=1 to d do begin inc(k);  read(f,Sufiks[k]) end;
    inc(k);
    Sufiks[k]:='%'
  end; {for i }
  close(f);
  assign(f,'WYR.OUT');
  rewrite(f)
 end; {WczytajDane}

 function Nastepny(p1,p2:integer):integer;
 begin
  while (Sufiks[p1]=Sufiks[p2]) and (Sufiks[p1]<>'%') and (Sufiks[p2]<>'%') do
   begin inc(p1);  inc(p2) end;
  if Sufiks[p1]='%' then Nastepny:=p2
  else
   if Sufiks[p2]='%' then Nastepny:=p1
   else if Sufiks[p1]<>Sufiks[p2] then Nastepny:=0
 end; {Nastepny}

begin
 WczytajDane;
 d:=0;
 for i:=1 to MaxTotalSize do Odwiedzony[i]:=false;
 NowyKoniec:=1;
 StaryKoniec:=0;
 p:=Nastepny(Poczatek[1],Poczatek[2]);
 if p=0 then WynikNie;
 if Sufiks[p]='%' then WynikTak(0);
 ZbiorOdwiedzonych[1]:=p;
 repeat
  Koniec:=NowyKoniec;
  inc(d);
  for i:=Koniec downto StaryKoniec+1 do
   for j:=3 to n+2 do begin
    p1:=ZbiorOdwiedzonych[i];
    p2:=Poczatek[j];
    p:=Nastepny(p1,p2);
    if (p<>0) and (Sufiks[p]='%') then WynikTak(d);
    if (p<>0) and not Odwiedzony[p] then begin
     inc(NowyKoniec);
     ZbiorOdwiedzonych[NowyKoniec]:=p;
     Odwiedzony[p]:=true
    end {if }
   end; {for }
   StaryKoniec:=Koniec
 until Koniec=NowyKoniec;
  {Zaden nowy element nie zostal wstawiony}
 WynikNie
end. {WyrownywanieSlow}

